.586p
include vmm.inc
include vwin32.inc
include v86mmgr.inc

VxDName TEXTEQU <z>
ControlName TEXTEQU <z_Control>
VxDMajorVersion TEXTEQU <1>
VxDMinorVersion TEXTEQU <0>

VxD_STATIC_DATA_SEG
VxD_STATIC_DATA_ENDS

VXD_LOCKED_CODE_SEG
DECLARE_VIRTUAL_DEVICE %VxDName,%VxDMajorVersion,%VxDMinorVersion, %ControlName,UNDEFINED_DEVICE_ID,UNDEFINED_INIT_ORDER

Begin_control_dispatch %VxDName
	Control_Dispatch W32_DEVICEIOCONTROL, OnDeviceIoControl
End_control_dispatch %VxDName

VXD_LOCKED_CODE_ENDS

VXD_PAGEABLE_CODE_SEG
BeginProc OnDeviceIoControl
	assume esi:ptr DIOCParams
	.if [esi].dwIoControlCode==1

	assume ECX:ptr _roak_read_struc	; LOOK AT STRUCTURE FROM LOADER TO GET INFO
	mov ECX, [esi].lpvInBuffer
	mov AX, [ECX].read_write_cd_function
	mov cd_read_struc.read_write_cd_function, AX
	mov AX, [ECX].drive
	mov cd_read_struc.drive, AX
	mov AX, [ECX].number_sectors_to_read
	mov cd_read_struc.number_sectors_to_read, AX
	mov AX, [ECX].sector_number_high
	mov cd_read_struc.sector_number_high, AX
	mov AX, [ECX].sector_number_low
	mov cd_read_struc.sector_number_low, AX
	assume ECX:NOTHING			; 

	VMMCall Get_Sys_VM_Handle		; get system VM handle
	mov Handle, EBX	
	assume EBX:ptr cb_s
	mov EBP, [EBX + CB_Client_Pointer]	; get pointer to client register structure
	mov ECX, sizeof sector_buffer
	stc						; set carry flag to 1
	push ESI					; preserve contents of DIOCParams
	mov ESI, OFFSET32 sector_buffer
	push DS
	pop FS					; selector into FS
	VxDCall V86MMGR_Allocate_Buffer
	pop ESI					; bring back contents of DIOCParams
	jc EndI
	mov AllocSize, ECX
;...read cd sector..........................................................
	Push_Client_State
	VMMCall Begin_Nest_V86_Exec
	assume ebp:ptr Client_word_reg_struc
	mov EDX, EDI				; EDI contains VM86 memory block address

	mov AX, cd_read_struc.read_write_cd_function
	mov [ebp].Client_ax, AX			; read or write cd function

	mov AX, cd_read_struc.drive		; drive number
	mov [ebp].Client_cx, AX			; drive a = 0

	mov AX, cd_read_struc.number_sectors_to_read
	mov [ebp].Client_dx, AX			; read # sectors

	mov [ebp].Client_bx, DX			; ES:BX needs to
	shr EDX, 16					; contain segment & offset
	mov [ebp].Client_es, DX			; of sector buffer

	mov AX, cd_read_struc.sector_number_high
	mov [ebp].Client_si, AX			; sector number high

	mov AX, cd_read_struc.sector_number_low
	mov [ebp].Client_di, AX			; sector number low

	mov EAX, 2Fh				; interrupt 2Fh

	VMMCall Exec_Int				; call interrupt
	VMMCall End_Nest_Exec

	mov AX, [ebp].Client_ax
	mov err_test, AX

	Pop_Client_State
;...retrieve the data from ring 0 for ring 3..............................
	mov ECX, AllocSize
	stc
	mov EBX, Handle
	push ESI
	mov ESI, OFFSET32 cd_read_struc
	push DS
	pop FS
	VxDCall V86MMGR_Free_Buffer		; V86MMGR_Service from v86mmgr.inc
	pop ESI
	mov EDX, ESI
	assume EDX:ptr DIOCParams
	mov EDI, [EDX].lpvOutBuffer		; a member of DIOCParams from vwin32.inc
	
	.if (err_test == 0)
	mov ESI, OFFSET32 sector_buffer	; OFFSET32 = offset flat from vmm.inc
	.else
	mov ESI, OFFSET32 err_buf
	.endif

	mov ECX, sizeof sector_buffer		; length 
	rep movsb					; copy source string DS:SI to ES:DI 
	mov byte ptr [EDI], 0			; make string null terminated
	mov ECX, [EDX].lpcbBytesReturned
	mov dword ptr [EDX], sizeof sector_buffer
EndI:
	.endif
	xor EAX, EAX
	ret
EndProc OnDeviceIoControl
VXD_PAGEABLE_CODE_ENDS

VXD_PAGEABLE_DATA_SEG
_roak_read_struc			STRUC
	read_write_cd_function	DW ?		; 1508h for read
	drive				DW ?		; A = 0
	number_sectors_to_read	DW ?		; # of sectors to read or write
	sector_number_high	DW ?		; starting sector number high
	sector_number_low		DW ?		; starting sector number low
_roak_read_struc			ENDS
	cd_read_struc		_roak_read_struc <>
	sector_buffer		DB 2048 dup(0)
	err_test			DW 0
	err_buf			DB 'ERROR READING CD SECTOR!', 0
	Handle			DD 0
	AllocSize			DD 0
VXD_PAGEABLE_DATA_ENDS

end
